

// find msgIdentity Element and give Parents a name ...
var Obj_MsgIdentity = document.getElementById("msgIdentity");

var parent_hbox = Obj_MsgIdentity.parentNode;
parent_hbox.setAttribute("id", "msgIdentityHbox");

var new_vbox = document.createElement("vbox");
new_vbox.setAttribute("id", "msgIdentityVbox");
new_vbox.setAttribute("flex", "1");


parent_hbox.replaceChild(new_vbox, Obj_MsgIdentity);

new_vbox.appendChild(Obj_MsgIdentity);

var origGenericSendMessage = null;
var origComposeUnload = null;
var origLoadIdentity = null;

function open_homepage()
{
var messenger = Components.classes["@mozilla.org/messenger;1"].createInstance();
messenger = messenger.QueryInterface(Components.interfaces.nsIMessenger);
messenger.launchExternalURL("http://absorb.it/hacked/thunderbird/v_identity.html");
//~ window.open("http://absorb.it/hacked/thunderbird/v_identity.html");
}


// replace FillIdentityListPopup with our own version to prevent showing
// Virtual Identity Accounts in diiferent MailCompose Dialogs
dump("## V_Identity: replace FillIdentityListPopup\n");
FillIdentityListPopup = function (popup) {VIdentity_FillIdentityListPopup(popup);}

function VIdentity_FillIdentityListPopup(popup)
{
  var accounts = queryISupportsArray(gAccountManager.accounts, Components.interfaces.nsIMsgAccount);
  accounts.sort(compareAccountSortOrder);

  for (var i in accounts) {
  
    var server = accounts[i].incomingServer;
    // changed next line to ignore (other) VirtualIdentity Accounts
    if (!server || server.hostName == "VirtualIdentity")
       continue;
    var identites = queryISupportsArray(accounts[i].identities, Components.interfaces.nsIMsgIdentity);
    for (var j in identites) {
      var identity = identites[j];
      var item = document.createElement("menuitem");
      item.className = "identity-popup-item";
      item.setAttribute("label", identity.identityName);
      item.setAttribute("value", identity.key);
      item.setAttribute("accountkey", accounts[i].key);
      item.setAttribute("accountname", " - " + server.prettyName);
      popup.appendChild(item);
    }
  }
}


var active = null;
function expand()
{
     var Obj_SendMsgHeaders = document.getElementById("SendMsgHeaders");
     if (Obj_SendMsgHeaders.getAttribute("hidden") == "true") {
	if (active == null) {
		// FIRST CALL: initialize the hole Extension
		if (replaceGenericFuntions() == "true") {
			createVIdentity_Account();
			initNewFields();
			active = 1;
		}
		else {
		  Obj_expandButton.setAttribute("hidden", "true");
		  dump("WARNING:Cannot hook message sending -- you will not be able to fake Identitys\n");
		}
		}
 	  if (active == 1) { showExtension(); }
	}
     else
	{
	hideExtension()
	storeIdentity();
	updateDropdownMenu();
	}
}


function showExtension()
{
	var Obj_expandButton = document.getElementById("expandButton");
	var Obj_SendMsgHeaders = document.getElementById("SendMsgHeaders");
	var Obj_MsgIdentity = document.getElementById("msgIdentity");
	Obj_SendMsgHeaders.setAttribute("hidden", "false");
	Obj_MsgIdentity.setAttribute("hidden", "true");
	Obj_MsgIdentity.setAttribute("style", "background-color:transparent;")
	Obj_expandButton.setAttribute("class","expandHeaderViewButton");
}

function hideExtension()
{
	var Obj_expandButton = document.getElementById("expandButton");
	var Obj_SendMsgHeaders = document.getElementById("SendMsgHeaders");
	var Obj_MsgIdentity = document.getElementById("msgIdentity");
	Obj_SendMsgHeaders.setAttribute("hidden", "true");
	Obj_MsgIdentity.setAttribute("hidden", "false");
	Obj_MsgIdentity.setAttribute("style", "")
	Obj_expandButton.setAttribute("class","collapsedHeaderViewButton");
}


function replaceGenericFuntions()
{
	// some code borrowed from enigmail
	if (typeof(GenericSendMessage)=="function" && typeof(ComposeUnload)=="function" 
			&& typeof(LoadIdentity)=="function") {
	  // replace GenericSendMessage with our own version
	  dump("## V_Identity: replace GenericSendMessage\n");
	  origGenericSendMessage = GenericSendMessage;
	  GenericSendMessage = function (msgType) {VIdentity_GenericSendMessage(msgType);}
	  // replace ComposeUnload with our own version
	  dump("## V_Identity: replace ComposeUnload\n");
	  origComposeUnload = ComposeUnload;
	  ComposeUnload = function () {VIdentity_ComposeUnload();}
	  // replace LoadIdentity with our own version
	  dump("## V_Identity: replace LoadIdentity\n");
	  origLoadIdentity = LoadIdentity;
	  LoadIdentity = function (startup) {VIdentity_LoadIdentity(startup);}

	  return "true"}
	else {
	  dump("## V_Identity ERROR: could not replace your SendMessage and/or ComposeUnload Function, aborting\n"); 
	  return "false";
	  }
}

var VIdent_Account = null;
var MenuItem = null;
function createVIdentity_Account()
{
  var AccManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
  
  VIdent_Account = AccManager.createAccount();
  var VIdent_Identity = AccManager.createIdentity();
  
  VIdent_Account.addIdentity(VIdent_Identity);
  
  var Number = getNewAccountNumber();
  
  var server = AccManager.createIncomingServer("user"+Number,"VirtualIdentity","pop3");
  server.prettyName = "Virtual Identity " + Number;
  server.valid = false;
  VIdent_Account.incomingServer = server;
  server.valid = true;
  
  // add entry to identityList
  var identityListPopup = document.getElementById("msgIdentityPopup");
  MenuItem = document.createElement("menuitem");
  MenuItem.className = "identity-popup-item";
  MenuItem.setAttribute("value", VIdent_Account.defaultIdentity.key);
  
  identityListPopup.appendChild(MenuItem);
 
  dump("## V_Identity: New Account created "+server.prettyName+"\n");
}

function initNewFields()
{
	var identityElement_fullName = document.getElementById("msg_fullName");
	identityElement_fullName.value = gCurrentIdentity.fullName;
	var identityElement_useremail = document.getElementById("msg_useremail");
	identityElement_useremail.value = gCurrentIdentity.email;
	loadSMTP_server_list();
}

function VIdentity_ComposeUnload()
{
	VIdentity_Cleanup(); ComposeUnload();
}

function VIdentity_LoadIdentity(startup)
{
	dump("## V_Identity: Identity changed\n");
	var identityList = document.getElementById("msgIdentity");
	if (identityList.value != VIdent_Account.defaultIdentity.key)
		{ VIdentity_Cleanup(); LoadIdentity(startup);}
	else { origLoadIdentity(startup); }
}

function VIdentity_Cleanup()
{
  // restore functions
  if (origGenericSendMessage) { GenericSendMessage = origGenericSendMessage; origGenericSendMessage = null; }
  if (origComposeUnload) { ComposeUnload = origComposeUnload; origComposeUnload = null; }
  if (origLoadIdentity) { LoadIdentity = origLoadIdentity; origLoadIdentity = null; }
  
  
  // remove faked Account
  if (VIdent_Account) {
    var AccManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
    dump("## V_Identity: Account " + VIdent_Account.incomingServer.prettyName + " removed\n")
    AccManager.removeAccount(VIdent_Account);
  }
  
  // remove Menuitem
  if (MenuItem) {
    var identityListPopup = document.getElementById("msgIdentityPopup");
    identityListPopup.removeChild(MenuItem);
  }
  
  active = null;
  hideExtension();
}

function VIdentity_GenericSendMessage( msgType )
{
	dump("## V_Identity: VIdentity_GenericSendMessage\n");
	// dont allow user to fake identity if Message is not sended now!!!!
	if (msgType != nsIMsgCompDeliverMode.Now) {
		var AccManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
		var server = AccManager.defaultAccount.incomingServer.prettyName
		var name = AccManager.defaultAccount.defaultIdentity.fullName
		var email = AccManager.defaultAccount.defaultIdentity.email
		if (confirm("It's not possible to use Virtual Identity for " +
			"Sending Mail Later, Creating Drafts or Creating Templates.\n\n" +
			"Replace Virtual Identity with Default Identity (" +
			name + " " + email + " [" + server + "]) ?"))
			{
				VIdentity_Cleanup();
				// set MenuEntry to default one
				var identityList = document.getElementById("msgIdentity");
				identityList.value = AccManager.defaultAccount.defaultIdentity.key;
				identityList.setAttribute("label", AccManager.defaultAccount.defaultIdentity.identityName);
				identityList.setAttribute('accountname', " - " +  AccManager.defaultAccount.incomingServer.prettyName);
				identityList.setAttribute("accountkey", AccManager.defaultAccount.key);
  
				GenericSendMessage( msgType )
			}
		else { return; }
		}
	else
        {
		storeIdentity();
		updateDropdownMenu();
		origGenericSendMessage( msgType )	
	}
}



function updateDropdownMenu()
{
  //~ identityListPopup.removeChild(MenuItem);
  MenuItem.setAttribute("label", VIdent_Account.defaultIdentity.identityName);
  MenuItem.setAttribute("accountname", " - " +  VIdent_Account.incomingServer.prettyName);
  MenuItem.setAttribute("accountkey", VIdent_Account.key);
 
  // set the  account name on the menu list value.
  var identityList = document.getElementById("msgIdentity");
  identityList.setAttribute("label", VIdent_Account.defaultIdentity.identityName);
  identityList.setAttribute('accountname', " - " +  VIdent_Account.incomingServer.prettyName);
  identityList.setAttribute("accountkey", VIdent_Account.key);
  identityList.value = VIdent_Account.defaultIdentity.key;
}

function storeIdentity()
{
  var identityElement_fullName = document.getElementById("msg_fullName");
  var identityElement_useremail = document.getElementById("msg_useremail");
  var serverMenu = document.getElementById("smtp_server_list");
		
  VIdent_Account.defaultIdentity.setUnicharAttribute("fullName", identityElement_fullName.value);
  VIdent_Account.defaultIdentity.setCharAttribute("useremail", identityElement_useremail.value);
  
  if (serverMenu.selectedItem)
   VIdent_Account.defaultIdentity.smtpServerKey = serverMenu.selectedItem.getAttribute('key');
  
  
  dump("## V_Identity: Stored VirtualIdentity (name " + VIdent_Account.defaultIdentity.fullName + " email " +
	VIdent_Account.defaultIdentity.email + " smtp " + VIdent_Account.defaultIdentity.smtpServerKey +")\n");

}

//~ Checks if there is stil another VIdentity Account and creates a new one
function getNewAccountNumber()
{
  var accounts = queryISupportsArray(gAccountManager.accounts, Components.interfaces.nsIMsgAccount);
  
  var FreeVIdentityNumber = 0
  var i = 0
  while (i < accounts.length) {
    var server = accounts[i].incomingServer;
    if (server && server.hostName == "VirtualIdentity" 
	&& server.prettyName == "Virtual Identity "+ FreeVIdentityNumber) {
		FreeVIdentityNumber++; i = 0;}
    else { i++; }
    }
  return FreeVIdentityNumber;
}

// some code borrowed from showsmtpuser extension
function loadSMTP_server_list()
{
	var smtpService
	if (!smtpService)
        smtpService = Components.classes["@mozilla.org/messengercompose/smtp;1"].getService(Components.interfaces.nsISmtpService);
	var serverList = document.getElementById("smtp_server_list_popup");
	while (serverList.hasChildNodes())
		serverList.removeChild(serverList.lastChild);
	var serverMenu = document.getElementById("smtp_server_list");
    
	if (getCurrentIdentity().smtpServerKey) 
		var idserver = smtpService.getServerByKey(getCurrentIdentity().smtpServerKey);
	else	var idserver = smtpService.defaultServer;

	var defaultServer = smtpService.defaultServer;
	var servers = smtpService.smtpServers
    
	var serverCount = servers.Count();

	for (var i=0 ; i<serverCount; i++) {
		var server = servers.QueryElementAt(i, Components.interfaces.nsISmtpServer);
		if (!server.redirectorType) 
		{
		  var listitem = createSmtpListItemx(server);
		  serverList.appendChild(listitem);
		}
	}
	serverMenu.label = getNewHostnamex(idserver);
}

function createSmtpListItemx(server) {
    var listitem = document.createElement("menuitem");

    var hostname = getNewHostnamex(server);
    
    listitem.setAttribute("label", hostname);
    listitem.setAttribute("key", server.key);
    // give it some unique id
    listitem.id = "smtpServer." + server.key;

    return listitem;
}


function getNewHostnamex(server)
{
    var showAlias = true;
    var showUsername = true;
    var hideUsername = true;

    
    // reuse Preferences from ssun
    try { showAlias = prefService.getBoolPref("ssun.showalias"); } catch (ex) {}
    try { showUsername = prefService.getBoolPref("ssun.showusername"); } catch (ex) {}
    try { hideUsername = prefService.getBoolPref("ssun.hideusername"); } catch (ex) {}

    var hostname = server.hostname;
    var port = "";

    if (server.port)
      port = ":" + server.port;

    // SSUN: Get server alias
    var alias = "";
    if (showAlias) {
        try { alias = prefService.getCharPref("ssun." + server.key + ".alias"); } catch (ex) {}
        if (alias) {
            hostname = alias;
        } else {
            hostname += port;
        }
    } else {
        hostname += port;
    }

    // SSUN: Add username
    if (showUsername && (!showAlias || (showAlias && (!alias || !hideUsername))) && server.authMethod && server.username)
      hostname += " (" + server.username + ")";

    return hostname
}
